import { Signal } from "@preact/signals";

export type MenuState = {
  activeMenu: Signal<string>;
  activeState: Signal<"error" | "normal" | "loading">;
  commandInput: Signal<string>;
  visible: Signal<boolean>;
  menus: Record<string, Menu>;
};

export type MenuEntry = {
  cb: (state: MenuState, context: unknown) => void;
  meta?: string;
  visible?: boolean | ((context: unknown) => boolean);
  title: string;
  icon?: string;
};

export type Menu = {
  title: string;
  entries: MenuEntry[];
};
